Package org.apache.ignite.internal.processors.query

## Interface QueryEngine

All Superinterfaces:
  `GridComponent`, `GridProcessor`

All Known Subinterfaces:
  `IndexingQueryEngine`

All Known Implementing Classes:
  `NoOpQueryEngine`

    public interface QueryEngine
    extends GridProcessor

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.GridComponent

`GridComponent.DiscoveryDataExchangeType`

### Method Summary

All Methods Instance Methods Abstract Methods
`List<List<GridQueryFieldMetadata>>` `parameterMetaData​(@Nullable QueryContext ctx, String schemaName, String qry)`
`List<FieldsQueryCursor<List<?>>>` `query​(@Nullable QueryContext ctx, String schemaName, String qry, Object... params)`
`List<FieldsQueryCursor<List<?>>>` `queryBatched​(@Nullable QueryContext ctx, String schemaName, String qry, List<Object[]> batchedParams)`
`List<List<GridQueryFieldMetadata>>` `resultSetMetaData​(@Nullable QueryContext ctx, String schemaName, String qry)`

### Methods inherited from interface org.apache.ignite.internal.GridComponent

`collectGridNodeData, collectJoiningNodeData, discoveryDataType, onDisconnected, onGridDataReceived, onJoiningNodeDataReceived, onKernalStart, onKernalStop, onReconnected, printMemoryStats, start, stop, validateNode, validateNode`

### Method Detail

#### query

    List<FieldsQueryCursor<List<?>>> query​(@Nullable
                                           @Nullable QueryContext ctx,
                                           String schemaName,
                                           String qry,
                                           Object... params)
                                    throws IgniteSQLException

Parameters:
  `ctx` - Query context, may be null.
  `schemaName` - Schema name.
  `qry` - Query.
  `params` - Optional query parameters.
Returns:
  List of query cursors. Size of list depends on number of distinct queries in `qry`.
Throws:
  `IgniteSQLException` - If failed.

#### parameterMetaData

    List<List<GridQueryFieldMetadata>> parameterMetaData​(@Nullable
                                                         @Nullable QueryContext ctx,
                                                         String schemaName,
                                                         String qry)
                                                  throws IgniteSQLException

Parameters:
  `ctx` - Query context, may be null.
  `schemaName` - Schema name.
  `qry` - Query.
Returns:
  List of queries' parameters metadata. Size of list depends on number of distinct queries in `qry`.
Throws:
  `IgniteSQLException` - If failed.

#### resultSetMetaData

    List<List<GridQueryFieldMetadata>> resultSetMetaData​(@Nullable
                                                         @Nullable QueryContext ctx,
                                                         String schemaName,
                                                         String qry)
                                                  throws IgniteSQLException

Parameters:
  `ctx` - Query context, may be null.
  `schemaName` - Schema name.
  `qry` - Query.
Returns:
  List of queries' result sets metadata. Size of list depends on number of distinct queries in `qry`.
Throws:
  `IgniteSQLException` - If failed.

#### queryBatched

    List<FieldsQueryCursor<List<?>>> queryBatched​(@Nullable
                                                  @Nullable QueryContext ctx,
                                                  String schemaName,
                                                  String qry,
                                                  List<Object[]> batchedParams)
                                           throws IgniteSQLException

Parameters:
  `ctx` - Query context, may be null.
  `schemaName` - Schema name.
  `qry` - Query.
  `batchedParams` - Optional query parameters.
Returns:
  List of query cursors. Size of list equals to size of `batchedParams`.
Throws:
  `IgniteSQLException` - If failed.